/*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/********************************************************************
* Author: Virtualik <virty1k@mail.ru>
* WWW   : http://virtualsoft.narod.ru
* Copyright (c) 2003,2006 Virtualik  All rights reserved.
********************************************************************/

#ifndef __SNDPLAY_H
#define __SNDPLAY_H

#include "config.h"
#include <sys/param.h>
#include <unistd.h>

#ifndef EXTPLAYER

#include <fcntl.h>
#include <signal.h>
#include <stdlib.h>

#ifdef __FreeBSD__
#if __FreeBSD_version < 500000
#include <machine/soundcard.h>
#else
#include <sys/soundcard.h>
#endif
#endif                          /* // FreeBSD */

#ifdef __linux__
#include <linux/soundcard.h>
#endif                          /* // Linux */

#define EPSDSPNOTREADY 1
#define EPSOPEN        2
#define EPSNOTWAVE     3
#define EPSNOTPCM      4
#define EPSDSPSETUP1    5
#define EPSDSPSETUP2    6
#define EPSDSPSETUP3    7
#define EPSDSPSETUP4    8
#define EPSDSPSETUP5    9

#define FOURCC_WAVE 0x45564157
#define FOURCC_DATA 0x61746164

#define PCM_WAVE_FORMAT 1
#define DEV_DSP "/dev/dsp"

typedef struct {
    u_int32_t magic;              // always 'RIFF'
    u_int32_t length;             // length of file
    u_int32_t chunk_type;         // always 'WAVE'
    u_int32_t chunk_format;       // always 'fmt '
    u_int32_t chunk_length;       // length of data chunk
} riff_header;

typedef struct {
    u_int16_t format;             // always 1 (PCM)
    u_int16_t channels;           // 1 (monoral) or 2 (stereo)
    u_int32_t sample_rate;        // sampling rate (Hz)
    u_int32_t speed;              // byte / sec
    u_int16_t sample_size;        // bytes / sample
    u_int16_t precision;          // bits / sample 4, 8, 16
} waveheader;

int             PrepareDSP(char *);
void            CloseDSP();

#endif

int             PlaySound(char *);

#endif
